<?php
//********************************************************************
//* Piccy-Cabinet                                                    *
//* Copyright (c) Album-System All rights Reserved.                  *
//* url:http://www.album-system.com/                                 *
//* e-mail:webmaster@album-system.com                                *
//* Create：2007-03-01(Bata1)                                        *
//* Update：2007-06-10(Bata2)                                        *
//* Update：2007-06-30(0.1.00)                                       *
//* Update：2007-07-15(0.1.01)                                       *
//* Update：2007-07-25(0.1.02)                                       *
//********************************************************************
//================================================================
//コンフィグファイル読み込み
require_once("config_common.php");
//SQLモジュール読み込み
require_once("db_common.php");
//ログモジュール読み込み
require_once("logger.php");
//ログモジュール読み込み
require_once("album-core.php");


function now_time(){
	return date("Y-m-d H:i:s");
}

//POST GET配列一括変換
function cnv_formstr($array){
	foreach($array as $k => $v){
		if(is_array($v) == False){
			//「magic_quotes_gpc = On」のときエスケープ解除
			if(get_magic_quotes_gpc()){
				$v = stripslashes($v);
			}
			$v = htmlspecialchars($v);
			$array[$k] = $v;
		}else{
			$array[$k] = cnv_formstr($v);
		}
	}
	
	return $array;
}

//SQL文字コードに変換
function cnv_sqlstr($string){
       $det_enc = mb_detect_encoding($string, "UTF-8, EUC-JP, SJIS");
       if($det_enc and $det_enc != ENCDB){
               $string = mb_convert_encoding($string, ENCDB, $det_enc);
       }

       //バックスラッシュを付加
       $string = addslashes($string);
       return $string;
}

//表示文字コードに変換
function cnv_dispstr($string){
       $det_enc = mb_detect_encoding($string, "UTF-8, EUC-JP, SJIS");
       //echo $string." DET_ENC=".$det_enc."<br>";
       if($det_enc and $det_enc != ENCDISP){
               return mb_convert_encoding($string, ENCDISP, $det_enc);
       }else{
               return $string;
       }
}

//API出力文字コードに変換
function cnv_apistr($string){
       $det_enc = mb_detect_encoding($string, "UTF-8, EUC-JP, SJIS");
       if($det_enc and $det_enc != ENCAPI){
               return mb_convert_encoding($string, ENCAPI, $det_enc);
       }else{
               return $string;
       }
}

//UTF-8文字コードに変換
function cnv_utf8_str($string){
       $det_enc = mb_detect_encoding($string, "UTF-8, EUC-JP, SJIS");
       if($det_enc and $det_enc != "UTF-8"){
               return mb_convert_encoding($string, "UTF-8", $det_enc);
       }else{
               return $string;
       }
}

//SQLデータを表示用配列に変換
function cnv_disparray($res){
       while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)){
               foreach ($row as $key=>$val){
                       $cnv_row[$key] = cnv_dispstr($val);
               }
               $disparray[] = $cnv_row;
       }
       return $disparray;
}

//SQLレコードデータを表示用配列に変換
function cnv_disparray_row($row){
       foreach ($row as $key=>$val){
                       $cnv_row[$key] = cnv_dispstr($val);
       }
       return $cnv_row;
}

//SQLデータをAPI出力用用配列に変換
function cnv_apiarray($res){
       while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)){
               foreach ($row as $key=>$val){
                       $cnv_row[$key] = cnv_apistr($val);
               }
               $disparray[] = $cnv_row;
       }
       return $disparray;
}

//SQLレコードデータをAPI出力用用配列に変換
function cnv_apiarray_row($row){
       foreach ($row as $key=>$val){
                       $cnv_row[$key] = cnv_apistr($val);
       }
       return $cnv_row;
}

//0.1.01で追加。写真画像表示処理
function display_image_file($type,$cat_id, $album_id, $photo_name,$photo_mime_type){
	global $ConfigArray;
	
	switch ($type) {
		case "thumb1":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB1_DIR_NAME."/".$photo_name;
			break;
		case "thumb2":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB2_DIR_NAME."/".$photo_name;
			break;
		case "thumb3":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB3_DIR_NAME."/".$photo_name;
			break;
		case "thumb4":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB4_DIR_NAME."/".$photo_name;
			break;
		case "original":
			$photo_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".ORIGINAL_DIR_NAME."/".$photo_name;
			break;
		default:
			log_message(9999,"");
	}
	
	//$image = ImageCreateFromJpeg($photo_path);
 	//ImageJpeg($image);
 	//ImageDestroy($image);
	$fp = fopen($photo_path, "r");
	$photo_binary = fread($fp, filesize($photo_path));
	fclose($fp);
		
	header("Content-type: ".$photo_mime_type);
	echo $photo_binary;

}

function create_dir($target_basedir){
	if(!mkdir( $target_basedir , 0777)){
		log_message(6001," dir=".$target_basedir);
		return false;
	}
	
	//写真格納用ディレクトリ作成処理
	if(!mkdir( $target_basedir."/".ORIGINAL_DIR_NAME , 0777)){
		log_message(6001," dir=".$target_basedir."/".ORIGINAL_DIR_NAME);
		return false;
	}
	
	if(!mkdir( $target_basedir."/".THUMB1_DIR_NAME , 0777)){
		log_message(6001," dir=".$target_basedir."/".THUMB1_DIR_NAME);
		return false;
	}
	
	
	if(!mkdir( $target_basedir."/".THUMB2_DIR_NAME , 0777)){
		log_message(6001," dir=".$target_basedir."/".THUMB2_DIR_NAME);
		return false;
	}
	
	if(!mkdir( $target_basedir."/".THUMB3_DIR_NAME , 0777)){
		log_message(6001," dir=".$target_basedir."/".THUMB3_DIR_NAME);
		return false;
	}
	
	
	if(!mkdir( $target_basedir."/".THUMB4_DIR_NAME , 0777)){
		log_message(6001," dir=".$target_basedir."/".THUMB4_DIR_NAME);
		return false;
	}
	
	return true;
}

//フォルダ削除関数
function delete_dir($dir_name) {
	if ($handle = opendir("$dir_name")) {
		while (false !== ($item_name = @readdir($handle))) {
			if ($item_name != "." && $item_name != "..") {
				if (is_dir("$dir_name/$item_name")) {
					if(!delete_dir("$dir_name/$item_name")){
						return false;
					}
				}else {
					if(!@unlink("$dir_name/$item_name")){
						log_message(6003," file=".$dir_name."/".$item_name);
						return false;
					}
				}
			}
		}
	} else {
		log_message(6002," dir=".$dir_name);
		return false;
	}
	
	closedir($handle);
	if(!@rmdir($dir_name)){
		log_message(6004," dir=".$dir_name);
		return false;
	}
	return true;
}

function get_exif($file_path) {
     //Exif情報を配列へ
     if (($cls = exif_read_data($file_path, "EXIF")) == FALSE)   return false;
     foreach ($cls as $key=>$sect) {
         if (is_array($sect) == FALSE) {
             $exif[$key] = $sect;
         } else {
             foreach($sect as $name=>$val)   $exif[$key . $name] = $val;
        }
     }
return $exif;
}

//ZIP解凍後のイメージファイル収集
function gather_image_file($target_dir, $to_target_dir){
	log_message(9000,"解凍後ファイル収集開始 target_dir=".$target_dir."　to_target_dir=".$to_target_dir);
	if (!$handle = opendir($target_dir)) {
		//Todo
		echo "ERROR1\n".$handle;
		return false;
	}
	
	while (false !== ($item_name = readdir($handle))) {
		if ($item_name != "." && $item_name != "..") {
			if (is_dir($target_dir."/".$item_name)) {
				if(!gather_image_file($target_dir."/".$item_name, $to_target_dir)){
					return false;
				}
			}else {
				$path_parts = pathinfo($target_dir."/".$item_name);
				if(!strcasecmp("jpg",$path_parts["extension"])){
					$to_file_name = $to_target_dir."/".$item_name;
					if(!copy($target_dir."/".$item_name,$to_file_name)){
						//Todo
						echo "ERROR2";
						return false;
					}
				}
			}
		}
	}
	closedir($handle);
	return true;
}

//target_dir内のファイル一覧を取得
function gather_file_list($target_dir){
	if (!$handle = opendir($target_dir)) {
		//Todo
		echo "ERROR1";
		return false;
	}
	
	while (false !== ($item_name = readdir($handle))) {
		if ($item_name != "." && $item_name != "..") {
			if (!is_dir($target_dir."/".$item_name)) {
				$file_list_array[] = $item_name;
			}
		}
	}
	closedir($handle);
	
	return $file_list_array;
}

//target_dir内のディレクトリ一覧を取得
function gather_dir_list($target_dir){
	if (!$handle = opendir($target_dir)) {
		//Todo
		echo "ERROR1";
		return false;
	}
	while (false !== ($item_name = readdir($handle))) {
		if ($item_name != "." && $item_name != "..") {
			if (is_dir($target_dir."/".$item_name)) {
				$dir_list_array[] = $item_name;
			}
		}
	}
	closedir($handle);
	
	return $dir_list_array;	
}

//テンプレートリスト取得
function get_template_list(){
	global $TemplateName;
	if(($dir_list_array = gather_dir_list(TEMPLATE_DIR)) == false){
		//Todo エラーメッセージ
		return false;
	}
	foreach($dir_list_array as $k => $v){
		if(!strcmp(substr($v, 0, 4) ,TEMPLATE_PREFIX)){
			$val_array["template_dir"] = $v;
			$val_array["template_name"] = $TemplateName[$v];
			$template_name_list[] = $TemplateName[$v];
			$template_list[] = $val_array;
		}
	}
	array_multisort($template_name_list, SORT_ASC, SORT_STRING,$template_list);
	return $template_list;	
}

//バグ対策：失敗時の終了ステイタスfalseだと、アルバムが無いときと同じになる。
//よって、失敗時は、エラーコード9000をreturn
function get_all_album(){
    
	//全カテゴリループ
	$res1 = db_select_cat();
	if(!$res1){
		log_message(9000,"function(get_album_all) DBセレクトで失敗");
		//バグ対策
		return 9000;
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_album_list($row1["cat_id"]);
			if(!$res2){
				log_message(9000,"function(get_album_all) DBセレクトで失敗");
				//バグ対策
				return 9000;
			}
			while ($row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC)){
				$cat_val = cnv_disparray_row($row1);
				$album_val = cnv_disparray_row($row2);
				$album_list = array_merge($cat_val , $album_val);
				//log_message(9000,"album_list情報".print_r($album_list, True));
				$album_array[] = $album_list;
			}
		}
	}
	return $album_array;
}

//0.1.01で新規追加　失敗時は、エラーコード9000をreturan
function get_access_all_cat_user_id($user_id){
	
	//全カテゴリループ
	$res1 = db_select_cat();
	if(!$res1){
		log_message(9000,"function(get_access_all_cat_user_id) DBセレクトで失敗");
		//バグ対策
		return 9000;
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_access_user_id_cat_id($row1["cat_id"], $user_id);
			$access_check["access_ok"] = null;
			if(!$res2){
				log_message(9000,"function(get_access_all_cat_user_id) DBセレクトで失敗");
				return 9000;
			}
			$ret2 = $res2->numRows();
			if(DB::isError($ret2)){
				log_message(5003,"function=get_access_all_cat_user_id errorMessage=".DB::errorMessage($ret2));
				return 9000;
			}
			$cat_val = cnv_disparray_row($row1);
			if($ret2 == 1){
				$access_check["access_ok"] = "checked";
				$row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC);
				$access_val = cnv_disparray_row($row2);
				$cat_list = array_merge($cat_val , $access_val);
				$cat_list = array_merge($cat_list , $access_check);
			}else{
				$cat_list = array_merge($cat_val , $access_check);				
			}
			
			$cat_access_list_array[] = $cat_list;
		}
	}
	
	return $cat_access_list_array;
}

function get_all_album_normal_user($user_id){
	//全カテゴリループ
	$res1 = db_select_cat_access_user_id($user_id);
	if(!$res1){
		log_message(9000,"function(get_album_all) DBセレクトで失敗");
		//バグ対策
		return 9000;
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_album_create_user_id($row1["cat_id"], $user_id);
			if(!$res2){
				log_message(9000,"function(get_album_all) DBセレクトで失敗");
				//バグ対策
				return 9000;
			}
			while ($row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC)){
				$cat_val = cnv_disparray_row($row1);
				$album_val = cnv_disparray_row($row2);
				$album_list = array_merge($cat_val , $album_val);
				//log_message(9000,"album_list情報".print_r($album_list, True));
				$album_array[] = $album_list;
			}
		}
	}
	return $album_array;
}

function get_photo_val(){
	global $GetArray;
    global $AuthObj;
	
	$res = db_select_photo($GetArray["cat_id"], $GetArray["album_id"]);
	if(!$res){
		log_message(9000,"function(get_photo_val) DBセレクトで失敗");
		error_exit(99);
	}
	
	$current_cnv_row = null;
    $break_flag = false;
	while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)){
		$now_cnv_row = cnv_disparray_row($row);
        
        if($break_flag){
            $next_cnv_row = $now_cnv_row;
            break;
        }
		
		if($row["photo_id"] == $GetArray["photo_id"]){
            $break_flag = ture;
		}
		$prev_cnv_row = $current_cnv_row;
		$current_cnv_row = $now_cnv_row;
	}
	
	$photo_val["prev"] = $prev_cnv_row;
	$photo_val["current"] = $current_cnv_row;
	$photo_val["next"] = $next_cnv_row;
	
	return $photo_val;
}

function get_user_own_album($user_id){
	//カテゴリ一覧取得
	$res = db_select_cat();
	if(!$res){
		log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
		error_exit(99);
	}
	
	$album_list_res = null;
	//カテゴリでループ
	while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)){
		//アルバムリストで、対象ユーザが作成したアルバムリスト取得
		$res1 =db_select_album_create_user_id($row["cat_id"], $user_id);
		if(!$res1){
			log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
			error_exit(99);
		}
		$album_list_res = array_merge_recursive($album_list_res, $res1);
	}
	return $album_list_res;
}

//ユーザの所有するアルバムが「ある」場合　True
//ユーザの所有するアルバムが「ない」場合　False
function have_own_album($user_id){
	//カテゴリ一覧取得
	$res = db_select_cat();
	if(!$res){
		log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
		error_exit(99);
	}
	
	//カテゴリでループ
	while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)){
		//アルバムリストで、対象ユーザが作成したアルバム取得
		$res1 =db_select_album_create_user_id($row["cat_id"], $user_id);
		if(!$res1){
			log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
			error_exit(99);
		}
		$ret = $res1->numRows();
		if(DB::isError($ret)){
			log_message(5003,"errorMessage=".DB::errorMessage($ret));
			error_exit(99);
		}
		
		if($ret != 0){
			log_message(9000,"所有アルバム　カテゴリID：".$row["cat_id"]."　".$ret."個");
			return true;
		}
	}
	return false;
}

//ユーザの所有するアルバムが「ある」場合　True
//ユーザの所有するアルバムが「ない」場合　False
function have_own_album_in_cat($cat_id, $user_id){
	//対象ユーザが作成したアルバム取得
	$res =db_select_album_create_user_id($cat_id, $user_id);
	if(!$res){
		log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
		error_exit(99);
	}
	$ret = $res->numRows();
	if(DB::isError($ret)){
		log_message(5003,"errorMessage=".DB::errorMessage($ret));
		error_exit(99);
	}
	
	if($ret != 0){
		log_message(9000,"所有アルバム　カテゴリID：".$cat_id."　".$ret."個");
		return true;
	}
	return false;
}

//ユーザが作成者のカテゴリが「ある」場合　True
//ユーザが作成者のカテゴリが「ない」場合　False
function have_own_cat($user_id){
	//カテゴリ一覧取得
		//アルバムリストで、対象ユーザが作成したアルバム取得
	$res =db_select_cat_create_user_id($user_id);
	if(!$res){
		log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
		error_exit(99);
	}
	$ret = $res->numRows();
	if(DB::isError($ret)){
		log_message(5003,"errorMessage=".DB::errorMessage($ret));
		error_exit(99);
	}
	
	log_message(9000,"作成者となっているカテゴリ：".$ret."個");
	if($ret != 0){
		return true;
	}

	return false;
}

//最後のADMINユーザの場合　True
//最後のADMINじゃない場合　False
function is_last_admin_user($user_id){
	//対象ユーザ情報取得
	$res = db_select_user_id($user_id);
	if(!$res){
		log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
		error_exit(99);
	}
	$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
	$user_array = cnv_disparray_row($row);
	
	if(!strcmp($user_array["user_auth"],"ADMIN")){
		//ADMINユーザ一覧取得
		$res = db_select_admin_user_table();
		if(!$res){
			log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
			error_exit(99);
		}
		
		$ret = $res->numRows();
		if(DB::isError($ret)){
			log_message(5003,"errorMessage=".DB::errorMessage($ret));
			error_exit(99);
		}
		
		log_message(9000,"ADMINユーザ数：".$ret."人");
		if($ret <= 1){
			return true;
		}
	}
	return false;
}

//指定したアルバム名が「ある」場合　True
//指定したアルバム名が「ない」場合　False
function is_album_name_in_cat($cat_id, $album_name){
	//対象ユーザが作成したアルバム取得
	$res =db_select_album_name($cat_id, $album_name);
	if(!$res){
		log_message(9000,"function:get_user_own_album: DBセレクトで失敗");
		error_exit(99);
	}
	$ret = $res->numRows();
	if(DB::isError($ret)){
		log_message(5003,"errorMessage=".DB::errorMessage($ret));
		error_exit(99);
	}
	
	if($ret != 0){
		log_message(9000,"既にあるアルバム：".$album_name."　".$ret."個");
		return true;
	}
	return false;
}

function get_thumb_size($target_basedir, $src_file){
	global $ConfigArray;

	$src_image = ImageCreateFromJPEG($target_basedir."/".ORIGINAL_DIR_NAME."/".$src_file); //JPEGファイルを読み込む
	
	// 画像のサイズを取得。
	$width = ImageSX($src_image); //横幅（ピクセル）
	$height = ImageSY($src_image); //縦幅（ピクセル）
	
	// 縮小した画像のサイズを決める。
	
	//サムネイル１～４
	$counter = 1;
	while($counter <= 4 ){
		if(!strcmp($ConfigArray["root"]["album_config"]["PHOTO"]["thumb".$counter."_policy"], "fix_width")){
			$thumb_file_size["thumb".$counter]["width"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb".$counter."_width"];
			$rate = $thumb_file_size["thumb".$counter]["width"] / $width; //圧縮比
			$thumb_file_size["thumb".$counter]["height"] = $rate * $height;
		}else{
			$thumb_file_size["thumb".$counter]["height"] = $ConfigArray["root"]["album_config"]["PHOTO"]["thumb".$counter."_height"];
			$rate = $thumb_file_size["thumb".$counter]["height"] / $height; //圧縮比
			$thumb_file_size["thumb".$counter]["width"] = $rate * $width;
		}
		$counter++;
	}
	
	return $thumb_file_size;
}

function create_thumb($target_basedir, $src_file){
	global $ConfigArray;
	
	$thumb_size = get_thumb_size($target_basedir, $src_file);
	
	//サムネイル作成処理　１～４
	if(!create_jpeg_thumb($target_basedir,THUMB1_DIR_NAME,$src_file,
		$thumb_size["thumb1"]["width"],$thumb_size["thumb1"]["height"], 
		$ConfigArray["root"]["album_config"]["PHOTO"]["thumb1_comp_rate"])){
	//Todo
			echo "ERROR (create_jepeg_thumb())";
			return false;
	}
	if(!create_jpeg_thumb($target_basedir,THUMB2_DIR_NAME,$src_file,
		$thumb_size["thumb2"]["width"],$thumb_size["thumb2"]["height"], 
		$ConfigArray["root"]["album_config"]["PHOTO"]["thumb2_comp_rate"])){
	//Todo
			echo "ERROR (create_jepeg_thumb())";
			return false;
	}
	if(!create_jpeg_thumb($target_basedir,THUMB3_DIR_NAME,$src_file,
		$thumb_size["thumb3"]["width"],$thumb_size["thumb3"]["height"], 
		$ConfigArray["root"]["album_config"]["PHOTO"]["thumb3_comp_rate"])){
	//Todo
			echo "ERROR (create_jepeg_thumb())";
			return false;
	}
	if(!create_jpeg_thumb($target_basedir,THUMB4_DIR_NAME,$src_file,
		$thumb_size["thumb4"]["width"],$thumb_size["thumb4"]["height"], 
		$ConfigArray["root"]["album_config"]["PHOTO"]["thumb4_comp_rate"])){
	//Todo
			echo "ERROR (create_jepeg_thumb())";
			return false;
	}
	return true;
}

function create_photo($cat_id, $album_id, $photo_file_name, $create_user_id){
	global $ConfigArray;
	
	$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id;
	$target_photo_path = $target_basedir."/".ORIGINAL_DIR_NAME."/".$photo_file_name;
	//Exif情報取得
	$exif_array = get_exif($target_photo_path);
	
	$image_info = getimagesize($target_photo_path);
	
	//サムネイル画像サイズ計算
	$thumb_size = get_thumb_size($target_basedir, $photo_file_name);
	
	//写真一覧作成
	$res = db_insert_photo($cat_id, $album_id, $photo_file_name , "", 
			$create_user_id, 10, 0, 0, 0, filesize($target_photo_path), 
			$image_info[0], $image_info[1], $thumb_size["thumb1"]["width"], $thumb_size["thumb1"]["height"], 
			$thumb_size["thumb2"]["width"], $thumb_size["thumb2"]["height"], $thumb_size["thumb3"]["width"], $thumb_size["thumb3"]["height"], 
			$thumb_size["thumb4"]["width"], $thumb_size["thumb4"]["height"], $image_info["mime"], 
			$exif_array["DateTimeOriginal"], $exif_array["Model"], $exif_array["ExposureTime"], 
			$exif_array["FNumber"], $exif_array["ISOSpeedRatings"], 
			now_time(),now_time());
	if(!$res){
		log_message(9000,"Photoテーブル作成失敗");
		return false;
	}
	
	if(!create_thumb($target_basedir,$photo_file_name)){
		echo "ERROR";
		return false;	
	}
	return true;
}

//0.1.01に新規追加
function create_album_from_zip($cat_id, $album_id, $zip_file_name, $user_id){
	global $ConfigArray;
	
	//PEARパッケージ読み込み
	require_once("File/Archive.php");
	
	$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id;

	//PHP実行時間の上限を無制限に変更
	set_time_limit ( 0 );
	
	//WORKディレクトリ作成
	if(!mkdir( $target_basedir."/".WORK_DIR_NAME , 0777)){
		log_message(8001," dir=".$target_basedir);
		return false;
	}
	
	//１、ZIPファイル解凍
	$zip_path = $target_basedir."/".$zip_file_name;
	File_Archive::extract(
		File_Archive::read($zip_path."/"),
		File_Archive::appender($target_basedir."/".WORK_DIR_NAME."/")
	);
	
	//解凍後ファイル収集処理
	if(!gather_image_file($target_basedir."/".WORK_DIR_NAME, $target_basedir."/".ORIGINAL_DIR_NAME)){
		return false;
	}
		
	//３、サムネイル作成
	$file_list_array = gather_file_list($target_basedir."/".ORIGINAL_DIR_NAME);
	if(!$file_list_array){
		return false;
	}
	
	//配列をファイル名でソート
	asort($file_list_array, SORT_STRING);
	
	foreach ($file_list_array as $key=>$val){
		//拡張子がJPGであるか確認
		$path_parts = pathinfo($val);
		if(strcasecmp("JPG",$path_parts["extension"]) == 0){
			if(!create_photo($cat_id, $album_id, $val, $user_id)){
			}
		}
	}	
	
	//６、WORKディレクトリ削除
	delete_dir($target_basedir."/".WORK_DIR_NAME);
	
	//Todo アップロードファイル削除
	
	return true;
	
}

function update_thumb_photo($cat_id, $album_id, $photo_id, $photo_file_name){
	global $ConfigArray;
	
	$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id;
	$target_photo_path = $target_basedir."/".ORIGINAL_DIR_NAME."/".$photo_file_name;
	//Exif情報取得
	$exif_array = get_exif($target_photo_path);
	
	$image_info = getimagesize($target_photo_path);
	
	//サムネイル画像サイズ計算
	$thumb_size = get_thumb_size($target_basedir, $photo_file_name);
	
	//写真アップデート
	$res =db_update_photo_thmb($cat_id, $album_id, $photo_id, filesize($target_photo_path), 
			$image_info[0], $image_info[1], $thumb_size["thumb1"]["width"], $thumb_size["thumb1"]["height"], 
			$thumb_size["thumb2"]["width"], $thumb_size["thumb2"]["height"], $thumb_size["thumb3"]["width"], $thumb_size["thumb3"]["height"], 
			$thumb_size["thumb4"]["width"], $thumb_size["thumb4"]["height"], $image_info["mime"], 
			$exif_array["DateTimeOriginal"], $exif_array["Model"], $exif_array["ExposureTime"], 
			$exif_array["FNumber"], $exif_array["ISOSpeedRatings"], now_time());
	if(!$res){
		log_message(9000,"Photoデータアップデート失敗");
		return false;
	}
	
	if(!create_thumb($target_basedir,$photo_file_name)){
		echo "ERROR";
		return false;	
	}
	return true;
}

function del_photo($cat_id, $album_id, $photo_id){
	global $ConfigArray;
	
	//写真情報取得
	$res = db_select_photo_id($cat_id, $album_id, $photo_id);
	if(!$res){
		log_message(9000,"function(del_photo) DBセレクトで失敗");
		return false;
	}
	$photo_val = cnv_disparray($res);
	$photo_name = $photo_val[0]["photo_name"];
	
	//ファイル削除
	if(!unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".ORIGINAL_DIR_NAME."/".$photo_name)){
		log_message(6003,"file_name=".ORIGINAL_DIR_NAME."/".$photo_name);
		return false;
	}
	if(!unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB1_DIR_NAME."/".$photo_name)){
		log_message(6003,"file_name=".THUMB1_DIR_NAME."/".$photo_name);
		return false;
	}
	if(!unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB2_DIR_NAME."/".$photo_name)){
		log_message(6003,"file_name=".THUMB2_DIR_NAME."/".$photo_name);
		return false;
	}
	if(!unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB3_DIR_NAME."/".$photo_name)){
		log_message(6003,"file_name=".THUMB3_DIR_NAME."/".$photo_name);
		return false;
	}
	if(!unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$cat_id."_".$album_id."/".THUMB4_DIR_NAME."/".$photo_name)){
		log_message(6003,"file_name=".THUMB4_DIR_NAME."/".$photo_name);
		return false;
	}
	
	//レコード削除
	$res = db_del_photo_id($cat_id, $album_id, $photo_id);
	if(!$res){
		log_message(6005,"cat_id=".$cat_id." album_id=".$album_id." photo_name=".$photo_id);
		return false;
	}
	
	return true;
}

//ファイルアップロード関数
//return 成功：ture 失敗;false
function get_user_file($save_dir_name, $file_name, $tmp_file_name) {
	global $ConfigArray;
	
	log_message(9000,"function(get_user_file) START");
	log_message(9000,"アップロードファイル情報".print_r($_FILES, True));
	
	$save_dir_path = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$save_dir_name;
	
	//ダウンロードファイル保存場所
	$save_file_path = $save_dir_path."/".$file_name;
	
	$user_file_name = $_FILES["user_file"]["name"];
	
	$path_parts = pathinfo("$user_file_name");
	
	if (!move_uploaded_file($tmp_file_name,
		//$_FILES["user_file"]["tmp_name"], 
		$save_file_path ) ) {
		log_message(1019,"指定されたファイル名：".$path_parts["basename"]);
		return false;
	}
	
	return true ;
}

function exec_month_count_clear(){
    db_upadate_cat_show_count_month_clear();
    
    //全Album_list_table Photo_tableでループしてクリアー処理必要
    //カテゴリ一覧でループ→アルバムリストでループ→写真テーブル削除
	$res1 = db_select_cat();
	if(!$res1){
		log_message(1021,"table=cat_table");
		return false;
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_album_list($row1["cat_id"]);
			if(!$res2){
				log_message(1021,"table=album_list_table");
				return false;
			}
			while ($row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC)){
				$res3 = db_upadate_photo_show_count_month_clear($row1["cat_id"], $row2["album_id"]);
				if(!$res3){
					log_message(1003,"table=photo_table");
					return false;
				}
			}
			$res4 = db_upadate_album_show_count_month_clear($row1["cat_id"]);
			if(!$res4){
				log_message(1003,"table=album_list_table");
				return false;
			}
		}
	}
    return true;
}

//当月最初のログインユーザかチェック
//当月最初のログインユーザの場合　True
//当月最初のログインユーザでない場合　False
function check_this_month_first_login(){
    //SQL発行
    $res = db_check_this_month_first_login();
    $row = $res->fetchRow(DB_FETCHMODE_ASSOC);
    log_message(9000,"user_last_access_time=".$row["user_last_access_time"]." flag=".$row["flag"]);
    if($row["flag"] == 0){
        return true;
    }
    return false;    
}

function check_exec_initial_step2(){
	global $PostArray;
	global $Conn;
	
	$check_flag = ture;
	
	//アルバム名チェック
	if($PostArray["album_name"] == ""){
		log_message(0101, "");
		$check_flag = false;
	}

	//テンプレート選択チェック
	if($PostArray["default_template"] == ""){
		log_message(0104, "");
		$check_flag = false;
	}

	//ログファイル入力チェック
	if($PostArray["log_file_name"] == ""){
		log_message(0102,"");
		$check_flag = false;
	}
	
	//ログファイル容量チェック
	if(!is_numeric($PostArray["log_file_size"])){
		log_message(0105,"");
		$check_flag = false;
	}
	
	//動作環境チェック処理
	//DB接続確認
	$Conn = db_conn_initial($PostArray["db_type"], $PostArray["db_user"], 
	$PostArray["db_pass"], $PostArray["db_host"], $PostArray["db_name"]);
	if(!$Conn){
		log_message(0106,"");
		$check_flag = false;
	}
	db_close();

	//写真フォルダ書き込み確認
	if(!is_writable ($PostArray["save_dir"])){
		log_message(0107,"　PHOTO_Save_Dir=".$PostArray["save_dir"]);
		$check_flag = false;
	}
		
	//サーバ環境チェック
	//必要に応じて追加
	if (!extension_loaded("gd")) {
		log_message(0109,"");
		$check_flag = false;
	}
	if (!extension_loaded("exif")) {
		log_message(0110,"");
		//$check_flag = false;　動作はするので、falseはなし
	}
	$post_max_size = ini_get_return_bytes(ini_get("post_max_size"));
	$memory_limit = ini_get_return_bytes(ini_get("memory_limit"));
	$upload_max_filesize = ini_get_return_bytes(ini_get("upload_max_filesize"));
	log_message(9000,"　memory_limit=".$memory_limit."　post_max_size=".$post_max_size."　upload_max_filesize=".$upload_max_filesize);
	log_message(9000,"　memory_limit=".ini_get("memory_limit")."　post_max_size=".ini_get("post_max_size")."　upload_max_filesize=".ini_get("upload_max_filesize"));
	if(!($memory_limit >= $post_max_size && $post_max_size >= $upload_max_filesize)){
		log_message(0111,"　memory_limit=".$memory_limit."　post_max_size=".$post_max_size."　upload_max_filesize=".$upload_max_filesize);
		//$check_flag = false;　動作はするので、falseはなし
	}
	//0.1.01より空もOK
/*	//PHP実行確認(今は、入力確認のみ)
	if($PostArray["cmd"] == "" || $PostArray["nul"] == "" ){
		log_message(0108,"　cmd=".$PostArray["cmd"]."　nul=".$PostArray["nul"]);
		$check_flag = false;
	}*/
	return $check_flag;
}

function check_exec_change_config(){
	global $PostArray;
	global $Conn;
	
	$check_flag = ture;
	
	//アルバム名チェック
	if($PostArray["album_name"] == ""){
		log_message(0101, "");
		$check_flag = false;
	}
	//テンプレート選択チェック
	if($PostArray["default_template"] == ""){
		log_message(0104, "");
		$check_flag = false;
	}

	//サムネイル１選択チェック
	if($PostArray["thumb1_policy"] == ""){
		log_message(0112, "");
		$check_flag = false;
	}
	//サムネイル１高さ指定数値
	if(!strcmp($PostArray["thumb1_policy"],"fix_height")){
		if(!is_numeric($PostArray["thumb1_height"])){
			log_message(0113, "");
			$check_flag = false;
		}
	}
	//サムネイル１横幅指定数値
	if(!strcmp($PostArray["thumb1_policy"],"fix_width")){
		if(!is_numeric($PostArray["thumb1_width"])){
			log_message(0114, "");
			$check_flag = false;
		}
	}
	//サムネイル１圧縮率数値
	if(!is_numeric($PostArray["thumb1_comp_rate"])){
		log_message(0115, "");
		$check_flag = false;
	}
	//0-100の数値チェック
	if(0 > $PostArray["thumb1_comp_rate"] && $PostArray["thumb1_comp_rate"] > 100){
		log_message(0116, "");
		$check_flag = false;
	}

	//サムネイル２選択チェック
	if($PostArray["thumb2_policy"] == ""){
		log_message(0117, "");
		$check_flag = false;
	}
	//サムネイル２高さ指定数値
	if(!strcmp($PostArray["thumb2_policy"],"fix_height")){
		if(!is_numeric($PostArray["thumb2_height"])){
			log_message(0118, "");
			$check_flag = false;
		}
	}

	//サムネイル２横幅指定数値
	if(!strcmp($PostArray["thumb2_policy"],"fix_width")){
		if(!is_numeric($PostArray["thumb2_width"])){
			log_message(0119, "");
			$check_flag = false;
		}
	}
	//サムネイル２圧縮率数値
	if(!is_numeric($PostArray["thumb2_comp_rate"])){
		log_message(0120, "");
		$check_flag = false;
	}
	//0-100の数値チェック
	if(0 > $PostArray["thumb2_comp_rate"] && $PostArray["thumb2_comp_rate"] > 100){
		log_message(0121, "");
		$check_flag = false;
	}

	//サムネイル３選択チェック
	if($PostArray["thumb3_policy"] == ""){
		log_message(0124, "");
		$check_flag = false;
	}
	//サムネイル３高さ指定数値
	if(!strcmp($PostArray["thumb3_policy"],"fix_height")){
		if(!is_numeric($PostArray["thumb3_height"])){
			log_message(0125, "");
			$check_flag = false;
		}
	}
	//サムネイル３横幅指定数値
	if(!strcmp($PostArray["thumb3_policy"],"fix_width")){
		if(!is_numeric($PostArray["thumb3_width"])){
			log_message(0126, "");
			$check_flag = false;
		}
	}
	//サムネイル３圧縮率数値
	if(!is_numeric($PostArray["thumb3_comp_rate"])){
		log_message(0127, "");
		$check_flag = false;
	}
	//0-100の数値チェック
	if(0 > $PostArray["thumb3_comp_rate"] && $PostArray["thumb3_comp_rate"] > 100){
		log_message(0128, "");
		$check_flag = false;
	}

	//サムネイル４選択チェック
	if($PostArray["thumb4_policy"] == ""){
		log_message(0129, "");
		$check_flag = false;
	}
	//サムネイル４高さ指定数値
	if(!strcmp($PostArray["thumb4_policy"],"fix_height")){
		if(!is_numeric($PostArray["thumb4_height"])){
			log_message(0130, "");
			$check_flag = false;
		}
	}

	//サムネイル４横幅指定数値
	if(!strcmp($PostArray["thumb4_policy"],"fix_width")){
		if(!is_numeric($PostArray["thumb4_width"])){
			log_message(0131, "");
			$check_flag = false;
		}
	}
	//サムネイル４圧縮率数値
	if(!is_numeric($PostArray["thumb4_comp_rate"])){
		log_message(0132, "");
		$check_flag = false;
	}
	//0-100の数値チェック
	if(0 > $PostArray["thumb4_comp_rate"] && $PostArray["thumb4_comp_rate"] > 100){
		log_message(0133, "");
		$check_flag = false;
	}
	
	//ログファイル入力チェック
	if($PostArray["log_file_name"] == ""){
		log_message(0102,"");
		$check_flag = false;
	}
	
	//ログファイル容量チェック
	if(!is_numeric($PostArray["log_file_size"])){
		log_message(0105,"");
		$check_flag = false;
	}
	
	return $check_flag;
}

function ini_get_return_bytes($val) {
    $val = trim($val);
    $last = strtolower($val{strlen($val)-1});
    switch($last) {
        // 'G' は、PHP 5.1.0 より有効となる
        case 'g':
            $val *= 1024;
        case 'm':
            $val *= 1024;
        case 'k':
            $val *= 1024;
    }

    return $val;
}

function create_default_table(){
	//テーブル作成
	//user_table作成
	$res = db_create_user_table();
	if(!$res){
		log_message(1004,"table=user_table");
		return false;
	}
	//cat_table作成
	$res = db_create_cat_table();
	if(!$res){
		log_message(1004,"table=cat_table");
		return false;
	}
	//access_table作成
	$res = db_create_access_table();
	if(!$res){
		log_message(1004,"table=access_table");
		return false;
	}
	
	return true;
}

function delte_all_table_and_photo(){
	global $ConfigArray;
	
	//写真保存フォルダ初期化
	delete_dir($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]);
	@mkdir ( $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"] , 0777);
	chmod ( $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"] , 0777);
	
	//テーブル削除
	//access_table削除
	$res = db_drop_access_table();
	if(!$res){
		log_message(1003,"table=access_table");
	}
	
	//カテゴリ一覧でループ→アルバムリストでループ→写真テーブル削除
	$res1 = db_select_cat();
	if(!$res1){
		log_message(1021,"table=cat_table");
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_album_list($row1["cat_id"]);
			if(!$res2){
				log_message(1021,"table=album_list_table");
			}
			while ($row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC)){
				$res3 = db_drop_photo_table($row1["cat_id"], $row2["album_id"]);
				if(!$res3){
					log_message(1003,"table=photo_table");
				}
			}
			$res4 = db_drop_album_list_table($row1["cat_id"]);
			if(!$res4){
				log_message(1003,"table=album_list_table");
			}
		}
	}
	//cat_table削除
	$res = db_drop_cat_table();
	if(!$res){
		log_message(1003,"table=cat_table");
	}
	
	//user_table削除
	$res = db_drop_user_table();
	if(!$res){
		log_message(1003,"table=user_table");
	}
	
	//バージョンファイル削除
	if(!@unlink(VERSION_FILE)){
		//Todo ログ調整必要
		log_message(1006,"");
	}
	
	//コンフィグファイル削除
	if(!@unlink(CONFIG_FILE_NAME)){
		//Todo ログ調整必要
		log_message(1006,"");
	}
}

//アクセス権チェック系関数
//ADMINチェック　ADMINならば、「true」、ADMIN以外は、「false」を返す。
function check_auth_admin(){
	global $AuthObj;
	if(!strcmp($AuthObj->getAuthData("user_auth"),"ADMIN")){
		return true;
	}else{
		return false;
	}	
}

//GUEST以外であるかチェック　GUEST以外ならば、「true」、GUESTならば、「false」を返す
function check_not_auth_guest(){
	global $AuthObj;
	if(!strcmp($AuthObj->getAuthData("user_auth"),"GUEST")){
		return false;
	}else{
		return true;
	}	
}

//ADMIN or カテゴリアクセスユーザか？チェック
function check_cat_access($cat_id){
	global $AuthObj;
	if(!strcmp($AuthObj->getAuthData("user_auth"),"ADMIN")){
		return true;
	}else{
		//カテゴリにアクセス可能ユーザか？
		$res = db_select_access_user_id_cat_id($cat_id, $AuthObj->getAuthData("user_id"));
		if(!$res){
			log_message(9000,"function:check_cat_access: DBセレクトで失敗");
			return false;
		}
		$ret = $res->numRows();
		if(DB::isError($ret)){
			log_message(5003,"function=check_cat_access errorMessage=".DB::errorMessage($ret));
			return false;
		}
		if($ret != 1){
			log_message(6006,"user_id=".$AuthObj->getAuthData("user_id")." cat_id=".$cat_id." row_count=".$ret);
			return false;
		}
		return true;
	}
}

//ADMIN or カテゴリアクセスユーザか？チェック and not GUEST
function check_cat_access_not_guest($cat_id){
	global $AuthObj;
	if(!strcmp($AuthObj->getAuthData("user_auth"),"ADMIN")){
		return true;
	}else{
		//カテゴリにアクセス可能ユーザか？
		$res = db_select_access_user_id_cat_id($cat_id, $AuthObj->getAuthData("user_id"));
		if(!$res){
			log_message(9000,"function:check_cat_access: DBセレクトで失敗");
			return false;
		}
		$ret = $res->numRows();
		if(DB::isError($ret)){
			log_message(5003,"function=check_cat_access errorMessage=".DB::errorMessage($ret));
			return false;
		}
		if($ret != 1){
			log_message(6006,"user_id=".$AuthObj->getAuthData("user_id")." cat_id=".$cat_id." row_count=".$ret);
			return false;
		}
		return check_not_auth_guest;
	}
}

//ADMIN or アルバム作成ユーザか？　チェック
function check_album_create_user($cat_id,$album_id){
	global $AuthObj;
	if(!strcmp($AuthObj->getAuthData("user_auth"),"ADMIN")){
		return true;
	}else{
		//アルバム作成ユーザか？
		$res = db_select_album_id($cat_id,  $album_id);
		if(!$res){
			log_message(9000,"function:check_album_create_user: DBセレクトで失敗");
			return false;
		}
		$album_row = $res->fetchRow(DB_FETCHMODE_ASSOC);
		if($AuthObj->getAuthData("user_id") != $album_row["album_create_user_id"]){
			log_message(6007,"user_id=".$AuthObj->getAuthData("user_id") ." cat_id=".$cat_id." album_id=".$album_id);
			return false;
		}
		return true;
	}
}

//ユーザIDが正しいかチェック
function check_user_name_not_guest($user_name){
	global $AuthObj;
	log_message(9000,"function:check_user_name_not_guest: START user_name=".$user_name);
	if(strcmp($AuthObj->getUsername(), $user_name)){
		log_message(6008,"user_name=".$AuthObj->getUsername());
		return false;
	}else{
		return check_not_auth_guest();
	}
}

//バージョンファイル作成
function create_version_file($version){

	if(!($fp = fopen(VERSION_FILE, "w"))){
		return false;
	}
	flock($fp, LOCK_EX);
	fwrite($fp, $version);
	fwrite($fp, "\n");
	fwrite($fp, now_time());
	fwrite($fp, "\n");
	flock($fp, LOCK_UN);
	fclose($fp);
	
	return true;
}

function exec_all_thumb_update(){
	global $ConfigArray;

	//PHP実行時間の上限を無制限に変更
	set_time_limit ( 0 );
	
	//全カテゴリループ
	$res1 = db_select_cat();
	if(!$res1){
		log_message(9000,"function(exec_all_thumb_update) DBセレクトで失敗");
		return false;
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_album_list($row1["cat_id"]);
			if(!$res2){
				log_message(9000,"function(exec_all_thumb_update) DBセレクトで失敗");
				return false;
			}
			while ($row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC)){
				$res3 = db_select_photo($row1["cat_id"],$row2["album_id"]);
				if(!$res3){
					log_message(9000,"function(exec_all_thumb_update) DBセレクトで失敗");
					return false;
				}
				while ($row3 = $res3->fetchRow(DB_FETCHMODE_ASSOC)){
					//写真ループ
					$photo_val = cnv_disparray_row($row3);
					
					//サムネイル削除
					if(!@unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$row1["cat_id"]."_".$row2["album_id"]."/".THUMB1_DIR_NAME."/".$photo_val["photo_name"])){
						log_message(6003,"file_name=".THUMB1_DIR_NAME."/".$photo_val["photo_name"]);
					}
					if(!@unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$row1["cat_id"]."_".$row2["album_id"]."/".THUMB2_DIR_NAME."/".$photo_val["photo_name"])){
						log_message(6003,"file_name=".THUMB2_DIR_NAME."/".$photo_val["photo_name"]);
					}
					if(!@unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$row1["cat_id"]."_".$row2["album_id"]."/".THUMB3_DIR_NAME."/".$photo_val["photo_name"])){
						log_message(6003,"file_name=".THUMB3_DIR_NAME."/".$photo_val["photo_name"]);
					}
					if(!@unlink($ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$row1["cat_id"]."_".$row2["album_id"]."/".THUMB4_DIR_NAME."/".$photo_val["photo_name"])){
						log_message(6003,"file_name=".THUMB4_DIR_NAME."/".$photo_val["photo_name"]);
					}					
										
					//サムネイル再作成
					if(!update_thumb_photo($row1["cat_id"], $row2["album_id"], $photo_val["photo_id"], $photo_val["photo_name"])){
						return false;
					}
				}
			}
		}
	}
}

function exec_update_01(){
	global $ConfigArray;
	
	//photo_table変更
	//thumb3,4フォルダ作成
	//全カテゴリループ
	$res1 = db_select_cat();
	if(!$res1){
		log_message(9000,"function(exec_update_01) DBセレクトで失敗");
		return false;
	}else{
		while ($row1 = $res1->fetchRow(DB_FETCHMODE_ASSOC)){
			$res2 = db_select_album_list($row1["cat_id"]);
			if(!$res2){
				log_message(9000,"function(exec_update_01) DBセレクトで失敗");
				return false;
			}
			while ($row2 = $res2->fetchRow(DB_FETCHMODE_ASSOC)){
				//アルバムループ
				//photo_table更新
				$res3 = db_alter_photo_table_alpha2($row1["cat_id"], $row2["album_id"]);
				if(!$res3){
					log_message(9000,"function(exec_update_01) photo_table更新失敗");
					return false;
				}				
				
				//thumb3,4フォルダ作成
				$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$row1["cat_id"]."_".$row2["album_id"];
				if(!mkdir( $target_basedir."/".THUMB3_DIR_NAME , 0777)){
					log_message(6001," dir=".$target_basedir."/".THUMB3_DIR_NAME);
					return false;
				}
				if(!mkdir( $target_basedir."/".THUMB4_DIR_NAME , 0777)){
					log_message(6001," dir=".$target_basedir."/".THUMB4_DIR_NAME);
					return false;
				}
			}
		}
	}
	//バージョンファイルアップデート
	if(!create_version_file("alpha-02")){
		return false;
	}
	//コンフィグ情報アップデート
	if(!change_config_version("alpha-02")){
		return false;
	}
	//コンフィグ情報追加
	if(!update_config_01()){
		return false;
	}
	log_message(0005,"version=alpha-02");
	
	return true;
}

function exec_update_02(){
	global $ConfigArray;
	
	//バージョンファイルアップデート
	if(!create_version_file("0.1.00")){
		return false;
	}
	//コンフィグ情報アップデート
	if(!change_config_version("0.1.00")){
		return false;
	}
	//コンフィグ情報追加
	if(!update_config_01()){
		return false;
	}
	log_message(0005,"version=0.1.00");
	
	return true;
}

function exec_update_03(){
	global $ConfigArray;
	
	//バージョンファイルアップデート
	if(!create_version_file("0.1.01")){
		return false;
	}
	//コンフィグ情報アップデート
	if(!change_config_version("0.1.01")){
		return false;
	}
	//コンフィグ情報追加
	if(!update_config_02()){
		return false;
	}
	log_message(0005,"version=0.1.01");
	
	return true;
}

function exec_update_04(){
	global $ConfigArray;
	
	//バージョンファイルアップデート
	if(!create_version_file("0.1.02")){
		return false;
	}
	//コンフィグ情報アップデート
	if(!change_config_version("0.1.02")){
		return false;
	}

	log_message(0005,"version=0.1.02");
	
	return true;
}

?>